require "defines"
normal_attack_sent_event = game.generate_event_name()
landingattacksentevent = game.generate_event_name()
remote.add_interface("freeplay",
{
  set_attack_data = function(data)
    global.attack_data = data
  end,

  get_attack_data = function()
    return global.attack_data
  end,

  get_normal_attack_sent_event = function()
    return normal_attack_sent_event
  end,
})

init_attack_data = function()
  global.attack_data = {
    -- whether all attacks are enabled
    enabled = true,
    -- this script is allowed to change the attack values attack_count and until_next_attack
    change_values = true,
    -- what distracts the creepers during the attack
    distraction = defines.distraction.byenemy,
    -- number of units in the next attack
    attack_count = 5,
    -- time to the next attack
    until_next_attack = 60 * 60 * 60,
  }
end

 script.on_event(defines.events.on_tick, function(event)
  if global.deadPlayers ~= nil then
    for k, player in pairs(global.deadPlayers) do
    if player.character ~= nil then
        player.insert{name="iron-plate", count=50}
					
				  player.insert{name="steel-axe", count=3}
				  player.insert{name="repair-pack", count=50}
				  

				  player.insert{name="burner-inserter", count=50}
				  player.insert{name="basic-inserter", count=30}
				  player.insert{name="basic-transport-belt", count=200}
				  player.insert{name="small-electric-pole", count=20}
				  
				  
				  player.insert{name="submachine-gun", count=1}
				  player.insert{name="piercing-bullet-magazine", count=50}  
				  player.insert{name="combat-shotgun", count=1}
				  player.insert{name="piercing-shotgun-shell", count=50}  
				  player.insert{name="rocket-launcher", count=1}  
				  player.insert{name="rocket", count=50}
				  
				  player.insert{name="burner-mining-drill", count = 20}
				  player.insert{name="stone-furnace", count = 15}  
				  
				 player.insert{name="power-armor", count = 1}
         local p_armor = player.get_inventory(5)[1].grid
          p_armor.put({name = "fusion-reactor-equipment"})
          p_armor.put({name = "basic-exoskeleton-equipment"})
          p_armor.put({name = "energy-shield-mk2-equipment"})
          p_armor.put({name = "energy-shield-mk2-equipment"})
          p_armor.put({name = "personal-roboport-equipment"})
				player.insert{name="construction-robot", count = 10}
				player.insert{name="blueprint", count = 3}
				player.insert{name="deconstruction-planner", count = 1}
				  player.insert{name="electronic-circuit", count = 20}
        table.remove(global.deadPlayers, k) --p.print("You have respawned")
    end
    end
  end		
end)

script.on_event(defines.events.on_entity_died, function(event)
	if event.entity.type == "player" then
    if global.deadPlayers == nil then
          global.deadPlayers = {}
    end
  
      for k, connect_check in pairs (game.players) do 
        if connect_check.connected == true then --connect_check.print("Connected")
          if connect_check.character == nil then --connect_check.print("No character")
            table.insert(global.deadPlayers, connect_check)
          end
        end
      end        
        
   end
end)

script.on_event(defines.events.on_player_created, function(event)
  local player = game.get_player(event.player_index)
  
  player.insert{name="iron-plate", count=50}
					
				  player.insert{name="steel-axe", count=3}
				  player.insert{name="repair-pack", count=50}
				  

				  player.insert{name="burner-inserter", count=50}
				  player.insert{name="basic-inserter", count=30}
				  player.insert{name="basic-transport-belt", count=200}
				  player.insert{name="small-electric-pole", count=20}
				  
				  
				  player.insert{name="submachine-gun", count=1}
				  player.insert{name="piercing-bullet-magazine", count=50}  
				  player.insert{name="combat-shotgun", count=1}
				  player.insert{name="piercing-shotgun-shell", count=50}  
				  player.insert{name="rocket-launcher", count=1}  
				  player.insert{name="rocket", count=50}
				  
				  player.insert{name="burner-mining-drill", count = 20}
				  player.insert{name="stone-furnace", count = 15}  
				  
				 player.insert{name="power-armor", count = 1}
         local p_armor = player.get_inventory(5)[1].grid
          p_armor.put({name = "fusion-reactor-equipment"})
          p_armor.put({name = "basic-exoskeleton-equipment"})
          p_armor.put({name = "energy-shield-mk2-equipment"})
          p_armor.put({name = "energy-shield-mk2-equipment"})
          p_armor.put({name = "personal-roboport-equipment"})
				player.insert{name="construction-robot", count = 10}
				player.insert{name="blueprint", count = 3}
				player.insert{name="deconstruction-planner", count = 1}
				  player.insert{name="electronic-circuit", count = 20}
				  
				  player.color = {r=0.8, b= 0.8, g = 0.2}
  
  
  game.forces.player.logistic_robot_speed_modifier = 3	
	game.forces.player.technologies["automated-construction"].researched = true
	  
  if (#game.players <= 1) then
    game.show_message_dialog{text = {"msg-intro"}}
  end
end)

script.on_init(function()
  init_attack_data()
end)

-- for backwards compatibility
script.on_load(function()
  if global.attack_data == nil then
    init_attack_data()
    if global.attack_count ~= nil then global.attack_data.attack_count = global.attack_count end
    if global.until_next_attacknormal ~= nil then global.attack_data.until_next_attack = global.until_next_attacknormal end
  end
  if global.attack_data.distraction == nil then global.attack_data.distraction = defines.distraction.byenemy end
end)

script.on_event(defines.events.on_rocket_launched, function(event)
  local force = event.rocket.force
  if event.rocket.get_item_count("satellite") > 0 then
    if global.satellite_sent == nil then
      global.satellite_sent = {}
    end
    if global.satellite_sent[force.name] == nil then
      game.set_game_state{game_finished=true, player_won=true, can_continue=true}
      global.satellite_sent[force.name] = 1
    else
      global.satellite_sent[force.name] = global.satellite_sent[force.name] + 1
    end
    for index, player in pairs(force.players) do
      if player.gui.left.rocket_score == nil then
        local frame = player.gui.left.add{name = "rocket_score", type = "frame", direction = "horizontal", caption={"score"}}
        frame.add{name="rocket_count_label", type = "label", caption={"", {"rockets-sent"}, ""}}
        frame.add{name="rocket_count", type = "label", caption="1"}
      else
        player.gui.left.rocket_score.rocket_count.caption = tostring(global.satellite_sent[force.name])
      end
    end
  else
    if (#game.players <= 1) then
      game.show_message_dialog{text = {"gui-rocket-silo.rocket-launched-without-satellite"}}
    else
      for index, player in pairs(force.players) do
        player.print({"gui-rocket-silo.rocket-launched-without-satellite"})
      end
    end
  end
end)
